---
 linux-user/mmap.c |    8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

Index: qemu/linux-user/mmap.c
===================================================================
--- qemu.orig/linux-user/mmap.c	2007-12-03 15:40:25.000000000 +0000
+++ qemu/linux-user/mmap.c	2007-12-03 16:37:21.000000000 +0000
@@ -29,6 +29,10 @@
 
 //#define DEBUG_MMAP
 
+#ifndef MAP_32BIT
+#define MAP_32BIT 0
+#endif
+
 /* NOTE: all the constants are the HOST ones, but addresses are target. */
 int target_mprotect(abi_ulong start, abi_ulong len, int prot)
 {
@@ -251,7 +255,7 @@ abi_long target_mmap(abi_ulong start, ab
            especially important if qemu_host_page_size >
            qemu_real_host_page_size */
         p = mmap(g2h(mmap_start),
-                 host_len, prot, flags | MAP_FIXED, fd, host_offset);
+                 host_len, prot, flags | MAP_FIXED | MAP_32BIT, fd, host_offset);
         if (p == MAP_FAILED)
             return -1;
         /* update start so that it points to the file position at 'offset' */
@@ -406,7 +410,7 @@ abi_long target_mremap(abi_ulong old_add
     unsigned long host_addr;
 
     /* XXX: use 5 args syscall */
-    host_addr = (long)mremap(g2h(old_addr), old_size, new_size, flags);
+    host_addr = (long)mremap(g2h(old_addr), old_size, new_size, flags | MAP_32BIT);
     if (host_addr == -1)
         return -1;
     new_addr = h2g(host_addr);
